> ![MikroE](http://www.mikroe.com/img/designs/beta/logo_small.png)
> #Counter Cick#
> ##By [MikroElektronika](http://www.mikroe.com)
---

## Installation
Use the package manager to install the library for your architecture.

###Example

#include "resources.h"
#include "counter_click_hw.h"

// CLICK PINS
sbit COUNTER_CS at GPIOD_ODR.B13;
sbit COUNTER_EN at GPIOC_ODR.B2;

// TFT PINS
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;

uint64_t counter;
uint8_t mdr_0;
uint8_t mdr_1;
char counter_txt[100];

void DrawSFScr()
{
    TFT_Init_ILI9341_8bit(320,240);
    TFT_Fill_Screen(CL_WHITE);
    TFT_Set_Pen(CL_Black, 1);
    TFT_Line(20, 220, 300, 220);
    TFT_LIne(20,  46, 300,  46);
    TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_RED, FO_HORIZONTAL);
    TFT_Write_Text("COUNTER Click Demo", 60, 14);
    TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
    TFT_Write_Text("EasyMXv7", 19, 223);
    TFT_Set_Font(&Verdana12x13_Regular, CL_RED, FO_HORIZONTAL);
    TFT_Write_Text("www.mikroe.com", 200, 223);
    TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_BLACK, FO_HORIZONTAL);
    TFT_Write_Text("Number of impulses:", 70, 80);
}
void Mcu_Init()
{
    GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_2);
    GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_13);
    DrawSFScr();
    SPI3_Init_Advanced(_SPI_FPCLK_DIV8, _SPI_MASTER | _SPI_8_BIT |
                       _SPI_CLK_IDLE_LOW | _SPI_FIRST_CLK_EDGE_TRANSITION |
                       _SPI_MSB_FIRST | _SPI_SS_DISABLE | _SPI_SSM_ENABLE | _SPI_SSI_1,
                       &_GPIO_MODULE_SPI3_PC10_11_12);
    Delay_ms(1000);
}
void main()
{
     Mcu_Init();
     counter_init_advanced( COUNTER_4X_QUAD | COUNTER_FREE_RUN | COUNTER_INDEX_DISABLED | COUNTER_FILTER_CLOCK_DIV1,
                            COUNTER_MODE_24 | COUNTER_DISABLE | COUNTER_FLAG_DISABLE );
     counter_write_DTR( 0 );
     counter_load_CNTR();
     counter_enable();
     TFT_Set_Pen(CL_WHITE, 1);
     TFT_Set_Brush( 1, CL_WHITE, 0, 0, 0, 0 );
     while( 1 )
     {
            counter = counter_read_CNTR();
            sprintl( counter_txt, "%u", counter );
            TFT_Rectangle( 100, 110, 200, 135 );
            TFT_Write_Text( counter_txt, 100, 110);
            Delay_ms( 50 );
     }
}

